import { world, system } from '@minecraft/server';
import { Vector3 } from './Vector3.js';

var Vector = new Vector3();

var bowName = "yes_nexus:bow";
var bowName2 = "yes_nexus_ad1:bow";
var bowName3 = "yes_nexus_ad2:bow";
var bowName4 = "yes_nexus_ad3:bow";
var arrowName = "yes:nexus_arrow";
var snowballName = "yes:nexus_projectile";
var numOfNexusProjectiles = 7;
var nORP = numOfNexusProjectiles;




world.getAllPlayers().forEach(playerSpawnFunction)

world.afterEvents.playerSpawn.subscribe(async (eventData) => {
    var player = eventData.player;

    if(eventData.initialSpawn) {
        playerSpawnFunction(player);
    }
});



function playerSpawnFunction(player) {
    var identifier;
    try { 
        identifier = world.scoreboard.getObjective("identifier").getScore(player); 
        if(identifier == undefined) {
            player.runCommand(`scoreboard objectives add identifier dummy`); 
            player.runCommand(`scoreboard players random @s identifier -2000000000 2000000000`); 
            identifier = world.scoreboard.getObjective("identifier").getScore(player);
        }
    }
    catch { 
        player.runCommand(`scoreboard objectives add identifier dummy`); 
        player.runCommand(`scoreboard players random @s identifier -2000000000 2000000000`); 
        identifier = world.scoreboard.getObjective("identifier").getScore(player);
    }
    var scoreboardList = ["nexusProj", "using_nex_bow", "hit_id", "nex_bow_dur", "arrow_dmg", "is_critical", "proj_ticks", "proj_xRand", "proj_yRand"];
    for(var i=0; i<scoreboardList.length; i++) {
        try { world.scoreboard.addObjective(scoreboardList[i], scoreboardList[i]); } catch {}
    }
    var projList = player.dimension.getEntities({type: snowballName, scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]});

    for(var i=0; i<projList.length; i++) {
        projList[i].kill();
    }

    var pX = player.location.x;
    var pY = player.location.y;
    var pZ = player.location.z;
    var nexusTimer = 0;
    var nexusSpinTime = 0;
    var nexusProjList = [];

    var resetNexusEntity = -1;
    var wearingNexusArmor = -1;
    var wearingReaperArmor = -1;

    const testLoop = system.runInterval(() => {
        try { player.location }
        catch { 
            system.clearRun(testLoop); 
            return; 
        }
        //console.warn(player.getEntitiesFromViewDirection());
        pX = player.location.x;
        pY = player.location.y;
        pZ = player.location.z;

        var hasNexusSet  = player.runCommand(`testfor @s[hasitem=[{item=yes:nexus_helmet,location=slot.armor.head},{item=yes:nexus_chestplate,location=slot.armor.chest},{item=yes:nexus_leggings,location=slot.armor.legs},{item=yes:nexus_boots,location=slot.armor.feet}]]`).successCount;
        var hasReaperSet = player.runCommand(`testfor @s[hasitem=[{item=yes:reaper_helmet,location=slot.armor.head},{item=yes:reaper_chestplate,location=slot.armor.chest},{item=yes:reaper_leggings,location=slot.armor.legs},{item=yes:reaper_boots,location=slot.armor.feet}]]`).successCount;
        { //nexus set
            if(hasNexusSet) {
                wearingNexusArmor = 1;
                var rStep = (2*Math.PI)/nORP;
                var x;
                var z;
        
                var radius = 0.8;
                //var height = 2.5+Math.sin((2*Math.PI)*(nexusSpinTime/120))*0.25;
                var height = 0.9+Math.sin((2*Math.PI)*(nexusSpinTime/120))*0.25;
                var spawnHeight = pY+0.9;
                if(player.isSneaking) {
                    radius = 2;
                    //height = 0.6;
                    height = 0;
                    spawnHeight = pY+0.75;
                    nexusSpinTime++;
                }
                let rot = player.getRotation();
                //console.warn(`${rot.x}, ${rot.y}`);
                var spinAdd = (2*Math.PI)*(nexusSpinTime/120);
        
        
                if(nexusTimer >= 30 && nexusProjList.length < nORP) {
                    
                    const projectile = player.dimension.spawnEntity(snowballName, { 'x': pX, 'y': (spawnHeight), 'z': pZ });
                    projectile.runCommandAsync(`scoreboard players set @s identifier ${identifier}`);
                    projectile.runCommand(`scoreboard players set @s arrow_dmg 15`);
                    nexusProjList.push(projectile);
                    nexusTimer = 0;
                }
                else if(nexusProjList.length >= nORP) {
                    nexusTimer = 0;
                }
        
                target = player.dimension.getEntities({scoreOptions:[{objective: "hit_id", maxScore: identifier, minScore: identifier}]})[0];
                //console.warn(`target: ${target}`);
                for(var i=0; i<nexusProjList.length; i++) {
                    var target;
        
                    //console.warn(target);
                    try {
                        if(target != undefined && (nexusProjList[i].runCommand(`testfor @s[tag=start_attacking]`).successCount == 1)) {
                            nexusProjList[i].runCommand(`scoreboard players set @s nexusProj ${i}`);
                            
                        }
                        else {
                            //console.warn(`target: ${target}, tag: ${nexusProjList[i].runCommand(`testfor @s[tag=start_attacking]`).successCount == 0}`);
                            nexusProjList[i].runCommand(`scoreboard players set @s nexusProj ${i}`);
        
                            x = radius*Math.cos((Math.PI/2)+rStep*(i)+spinAdd);
                            z = radius*Math.sin((Math.PI/2)+rStep*(i)+spinAdd);
                            if(Math.abs(x) < 0.0001) {
                                x = 0;
                            }
                            if(Math.abs(z) < 0.0001) {
                                z = 0;
                            }
                            //player.runCommand(`say ${i} tag: ${nexusProjList[i].runCommand(`testfor @s[tag=start_attacking]`).successCount == 1}`);
                            nexusProjList[i].setRotation({ x: -rot.x, y: -rot.y});
                            player.runCommand(`execute as @s at @s anchored eyes run tp @e[C=1,type=${snowballName},scores={identifier=${identifier},nexusProj=${i}}] ^${x} ^${height} ^${z}`); 
                            //**nexusProjList[i].teleport({'x': pX+x, 'y': pY+height, 'z': pZ+z});
                        }
                        //else if(target == undefined) {
                        //    nexusProjList[i].runCommand(`tag @s remove attack`);
                        //    nexusProjList[i].runCommand(`tag @s remove start_attacking`);
                        //}
                    }
                    catch {
                        //console.warn(`removed ${i}`);
                        nexusProjList.splice(i, 1);
                    }
                }
                //console.warn(`target: ${target}`);
                if(target != undefined) {
                    
                    
                    var attackList = player.dimension.getEntities({type: snowballName, tags: ["start_attacking"], scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]});
                    //console.warn(`attackList: ${attackList}`);
                    for(var i=0; i<attackList.length; i++) {
                        projTargeting(player, attackList[i], target, rot);
                    }
                }
        
                var attackProjList = player.dimension.getEntities({type: snowballName, tags: ["attack"], scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]});
                if(target != undefined && attackProjList != "" ) {
                    resetNexusEntity = 1;
                }
        
                if((target == undefined || attackProjList == "") && resetNexusEntity == 0) {
                    for(var i=0; i<nexusProjList.length; i++) {
                        nexusProjList[i].runCommand(`tag @s remove attack`);
                        nexusProjList[i].runCommand(`tag @s remove start_attacking`);
                        nexusProjList[i].runCommand(`scoreboard players reset @s proj_ticks`);
                        nexusProjList[i].runCommand(`scoreboard players reset @s proj_xRand`);
                        nexusProjList[i].runCommand(`scoreboard players reset @s proj_yRand`);
                        nexusProjList[i].runCommand(`scoreboard players set @s arrow_dmg 15`);
                    }
                    player.runCommand(`scoreboard players reset @e hit_id`);
                    //console.warn(`reset all`);
                }
                if(resetNexusEntity > -1) {
                    resetNexusEntity--;
                }
        
        
        
        
                if(nexusSpinTime >= 120) {
                    nexusSpinTime = 0;
                }
                nexusSpinTime++;
                nexusTimer++;
            }
            else if(wearingNexusArmor == 0) {
                nexusSpinTime = 0;
                nexusTimer = 0;
                player.runCommand(`scoreboard players reset @e hit_id`);
                player.runCommand(`kill @e[type=${snowballName},scores={identifier=${identifier}}]`);
                nexusProjList = [];
            }
            if(wearingNexusArmor > -1) {
                wearingNexusArmor--;
            }
        }
        /*
        { //reaper set
            if(hasReaperSet) {
                var lookEntities = player.getEntitiesFromViewDirection();
                var closestEntity;
                lookEntities.forEach(e => {
                    if(e.entity.runCommand(`testfor @s[family=mob]`).successCount) {
                        closestEntity = e.entity;
                        return;
                    }
                });
                if(closestEntity != undefined) {
                    closestEntity.runCommand(`scoreboard players add @s reaper_timer 1`);
                }
            }
        }
        */
    }, 0);
}



function projTargeting(player, projectile, target, rot) {
    //console.warn(`zz`);
    let playerLocation = player.getHeadLocation();
    playerLocation.y += 0.9;

    let mobLocation = target.getHeadLocation();

    
    //time = x
    var ticks = world.scoreboard.getObjective("proj_ticks").getScore(projectile);

    //xRand = h,  random point where function becomes different
    var xRand = world.scoreboard.getObjective("proj_xRand").getScore(projectile)/100;
    //yRand = k,  maximum y displacement of proj
    var yRand = world.scoreboard.getObjective("proj_yRand").getScore(projectile)/100;

    
    //var playerLocationX = 12;
    //var playerLocationY = 78;
    //var playerLocationZ = 14;
//
    //var mobLocationX = 12;
    //var mobLocationY = 83;
    //var mobLocationZ = 34;

    //distance = p
    var distance = Math.sqrt(Math.pow(mobLocation.x-playerLocation.x,2)+Math.pow(mobLocation.z-playerLocation.z,2)+Math.pow(mobLocation.y-playerLocation.y,2));

    var maxTime = 3/4*Math.sqrt(distance/10);
    var maxTick = Math.round(maxTime*20);
    
    var time = (2/45)*Math.pow(ticks,2);
    if(ticks > maxTick) {
        ticks = maxTick;
        time = distance;
        
        //entity.runCommand(`tp @s 12 78 14`);
    }
    //console.warn(`ticks: ${ticks}`);

    //var time = (ticks/maxTick)*distance;

    //a1 = a1,  slope of function 1
    var a1 = -(yRand/(-time*distance+2*time*xRand-Math.pow(xRand,2)));

    var xDir;
    if(time <= xRand) { xDir = projFunction1(a1, time, xRand, yRand); }
    else { 
        //a2 = a2,  slope of function 2
        var a2 = (yRand/(-Math.pow(xRand,2)-Math.pow(distance,2)+2*xRand*distance));
        xDir = projFunction2(a2, time, xRand, yRand);  
    }
    var yDir = (mobLocation.y-playerLocation.y)/distance;


    var vector2 = Math.sqrt(xDir*xDir+time*time);
    var vector3 = Math.sqrt(xDir*xDir+time*time+yDir*yDir);

    var iThetaX = Math.atan(xDir/time);
    var iThetaY = Math.atan(yDir/vector2);
    //console.warn(iTheta);
    //var player = entity.dimension.getEntities({type: "minecraft:player"})[0];
    //let playerRot = player.getRotation();
    var deltaX = mobLocation.z-playerLocation.z;
    var deltaY = mobLocation.x-playerLocation.x;
    var thetaX;
    if     (deltaX < 0 && deltaY > 0) { thetaX = Math.atan(deltaY/deltaX)+Math.PI; }
    else if(deltaX < 0 && deltaY < 0) { thetaX = Math.atan(deltaY/deltaX)-Math.PI; }
    else                              { thetaX = Math.atan(deltaY/deltaX)          }
    
    var deltaR = Math.sqrt(deltaX*deltaX+deltaY*deltaY);
    var deltaZ = mobLocation.y-playerLocation.y;
    var thetaY = Math.atan(deltaZ/deltaR);

    
    //console.warn(`thetaX: ${thetaX}`);
    ///console.warn(`thetaY: ${thetaY}`);


    //var theta = (angle)*(Math.PI/180);

    var xRotation = roundToZero(iThetaX+thetaX);
    var sineX = roundToZero(Math.sin(xRotation));
    var cosineX = roundToZero(Math.cos(xRotation));

    var yRotation = roundToZero(thetaY);
    var sineY = roundToZero(Math.sin(yRotation));
    var cosineTest = roundToZero(Math.cos(thetaY));
    var sineTest = roundToZero(Math.sin(thetaY));

    
    //console.warn(`cosineY: ${cosineTest}`);
            //try {
            //    projectile.runCommand(`execute positioned ${playerLocation.x} ${playerLocation.y+0.4} ${playerLocation.z} as @s run tp @s ~${vector2*sineX*cosineTest}  ~${vector3*sineY}  ~${vector2*cosineX*cosineTest}`);
            //}
            //catch {
            //    
            //}
            
    let {x, y, z} = projectile.getHeadLocation();
    var newX = playerLocation.x+(vector2*sineX*cosineTest);
    var newY = playerLocation.y+(vector3*sineY);
    var newZ = playerLocation.z+(vector2*cosineX*cosineTest);
    try { projectile.teleport( { 'x': x, 'y': y, 'z': z }, { facingLocation: { 'x': newX, 'y': newY, 'z': newZ } } ); } catch {}
    
    let viewVector = projectile.getViewDirection();
    const rotation = projectile.getRotation();
    if (rotation.x > 30) {
        viewVector.x *= 2.1;
        viewVector.y *= 2.1;
        viewVector.z *= 2.1;
    }
    var velo = Math.sqrt(Math.pow(newX-x,2)+Math.pow(newY-y,2)+Math.pow(newZ-z,2));
    //console.warn(`velo: ${velo}`);
    //projectile.applyImpulse({ 'x': pX, 'y': (pY+3.5), 'z': pZ });
    projectile.clearVelocity();
    try { projectile.applyImpulse(new Vector.constructor(viewVector.x*velo, viewVector.y*velo, viewVector.z*velo)); } catch {}
    //console.warn(time);

    //let hPos = entity.getHeadLocation();
    //console.warn(`${hPos.x}, ${hPos.y}, ${hPos.z}`);

    projectile.runCommand(`scoreboard players add @s proj_ticks 1`);

    projectile.setRotation({ x: -rot.x, y: -rot.y});

}


/*
function projTargetingTest(player, projectile, target, rot, pX, pY, pZ) {
    //console.warn(`zz`);
    const { x, y, z } = projectile.getHeadLocation();

    let mobLocation = target.location;

    
    //time = x
    var ticks = world.scoreboard.getObjective("proj_ticks").getScore(projectile);

    //xRand = h,  random point where function becomes different
    var xRand = world.scoreboard.getObjective("proj_xRand").getScore(projectile)/100;
    //yRand = k,  maximum y displacement of proj
    var yRand = world.scoreboard.getObjective("proj_yRand").getScore(projectile)/100;

    
    //var playerLocationX = 12;
    //var playerLocationY = 78;
    //var playerLocationZ = 14;
//
    //var mobLocationX = 12;
    //var mobLocationY = 83;
    //var mobLocationZ = 34;

    //distance = p
    var distance = Math.sqrt(Math.pow(mobLocation.x-pX,2)+Math.pow(mobLocation.z-pZ,2)+Math.pow(mobLocation.y-pY,2));

    var maxTime = 2;
    var maxTick = 40;
    if(ticks > maxTick) {
        ticks = maxTick;
        
        //entity.runCommand(`tp @s 12 78 14`);
    }
    //console.warn(`ticks: ${ticks}`);

    //var time = (ticks/maxTick)*distance;
    var time = (ticks/maxTick)*distance;

    //a1 = a1,  slope of function 1
    var a1 = -(yRand/(-time*distance+2*time*xRand-Math.pow(xRand,2)));

    var xDir;
    if(time <= xRand) { xDir = projFunction1(a1, time, xRand, yRand); }
    else { 
        //a2 = a2,  slope of function 2
        var a2 = (yRand/(-Math.pow(xRand,2)-Math.pow(distance,2)+2*xRand*distance));
        xDir = projFunction2(a2, time, xRand, yRand);  
    }
    var yDir = (mobLocation.y-pY)/distance;

    var vector2 = Math.sqrt(xDir*xDir+time*time);
    var vector3 = Math.sqrt(xDir*xDir+time*time+yDir*yDir);

    var iThetaX = Math.atan(xDir/time);
    var iThetaY = Math.atan(yDir/vector2);
    //console.warn(iTheta);
    //var player = entity.dimension.getEntities({type: "minecraft:player"})[0];
    //let playerRot = player.getRotation();
    var deltaX = mobLocation.z-pZ;
    var deltaY = mobLocation.x-pX;
    var thetaX;
    if     (deltaX < 0 && deltaY > 0) { thetaX = Math.atan(deltaY/deltaX)+Math.PI; }
    else if(deltaX < 0 && deltaY < 0) { thetaX = Math.atan(deltaY/deltaX)-Math.PI; }
    else                              { thetaX = Math.atan(deltaY/deltaX)          }
    
    var deltaR = Math.sqrt(deltaX*deltaX+deltaY*deltaY);
    var deltaZ = mobLocation.y-pY;
    var thetaY = Math.atan(deltaZ/deltaR);

    
    //console.warn(`thetaX: ${thetaX}`);
    //console.warn(`thetaY: ${thetaY}`);


    //var theta = (angle)*(Math.PI/180);

    var xRotation = roundToZero(iThetaX+thetaX);
    var sineX = roundToZero(Math.sin(xRotation));
    var cosineX = roundToZero(Math.cos(xRotation));

    var yRotation = roundToZero(thetaY);
    var sineY = roundToZero(Math.sin(yRotation));
    var cosineTest = roundToZero(Math.cos(thetaY));
    var sineTest = roundToZero(Math.sin(thetaY));

    
    //console.warn(`cosineY: ${cosineTest}`);
    projectile.runCommand(`execute positioned ${pX} ${pY} ${pZ} as @s run tp @s ~${vector2*sineX*cosineTest}  ~${vector3*sineY}  ~${vector2*cosineX*cosineTest}`);
    //console.warn(time);

    //let hPos = entity.getHeadLocation();
    //console.warn(`${hPos.x}, ${hPos.y}, ${hPos.z}`);

    projectile.runCommand(`scoreboard players add @s proj_ticks 1`);

    projectile.setRotation({ x: -rot.x, y: -rot.y});
}
*/




//old projectile motion
/*
const { x, y, z } = projectile.getHeadLocation();
let face = target.getHeadLocation();
projectile.teleport( { 'x': x, 'y': y, 'z': z }, { facingLocation: face } );

let viewVector = projectile.getViewDirection();
const rotation = projectile.getRotation();
if (rotation.x > 30) {
    viewVector.x *= 2.1;
    viewVector.y *= 2.1;
    viewVector.z *= 2.1;
}
projectile.clearVelocity();
projectile.runCommand(`scoreboard objectives add proj_time dummy`);
projectile.runCommand(`scoreboard players add @s proj_time 1`);
//
var projTime = world.scoreboard.getObjective("proj_time").getScore(projectile)/20;
var velo;
var h = 0.5;
var k = 3;
var a = k/Math.pow(h,2);
//
if(projTime <= h) { velo = a*Math.pow(projTime,2); }
else if(h < projTime <= 2*h) { velo = -a*Math.pow(projTime-2*h,2)+2*k; }
else { velo = 2*k; }
projectile.applyImpulse(new Vector.constructor(viewVector.x*velo, viewVector.y*velo, viewVector.z*velo));
*/


/*
//for projectile motion

//time = x
var time;//

//distance = p
var distance = Math.sqrt(Math.pow(mobLocation.x-playerLocation.x,2)+Math.pow(mobLocation.y-playerLocation.y,2));

//xRand = h,  random point where function becomes different
var xRand = Math.random()*distance;
if(xRand == 0) {
    xRand += 0.01;
}

//yRand = k,  maximum y displacement of proj
var yRand = Math.random()*distance/4;

//a1 = a1,  slope of function 1
var a1 = -(yRand/(-time*distance+2*time*xRand-Math.pow(xRand,2)));

//x = time
//h = xRand
//k = yRand
function projFunction1(a1, x, h, k) {
    return -a1*Math.pow(x-h,2)+k;
}

//a2 = a2,  slope of function 2
var a2 = (yRand/(-Math.pow(xRand,2)-Math.pow(distance,2)+2*xRand*distance));

//x = time
//h = xRand
//k = yRand
function projFunction2(a2, x, h, k) {
    return -a2*Math.pow(x-h,2)+k;
}

//Angle between player & target
var angle = Math.atan((mobLocation.y-playerLocation.y)/(mobLocation.x-playerLocation.x));

*/















world.afterEvents.itemStartUse.subscribe((eventData) => {
    const item = eventData.itemStack;

    if(item.typeId == bowName || item.typeId == bowName2 || item.typeId == bowName3 || item.typeId == bowName4) {
        const entity = eventData.source;
        var chargeTime = 0;
        entity.runCommand(`scoreboard players set @s using_nex_bow 1`);
        
        var container = entity.getComponent('minecraft:inventory').container;
        var hasArrow = hasArrowTest(container);

        if(hasArrow || entity.runCommand(`testfor @s[m=c]`).successCount == 1) {
            const testLoop = system.runInterval(() => {
                //Performance Check//console.warn(`2 itemuse loop`);
                //Performance Check//world.scoreboard.getObjective("loopTime").addScore("item_loop", 1);
                //if(chargeTime >= 25) {
                //    entity.runCommand(`effect @s slowness 9999 5 true`);
                //    entity.runCommand(`effect @s speed 9999 44 true`);
                //}
                if(chargeTime >= 25) {
                    entity.runCommand(`effect @s slowness 9999 4 true`);
                    entity.runCommand(`effect @s speed 9999 14 true`);
                }
                else if(chargeTime >= 22) {
                    entity.runCommand(`effect @s slowness 9999 3 true`);
                    entity.runCommand(`effect @s speed 9999 6 true`);
                }
                else if(chargeTime >= 18) {
                    entity.runCommand(`effect @s slowness 9999 2 true`);
                    entity.runCommand(`effect @s speed 9999 3 true`);
                }
                else if(chargeTime >= 13) {
                    entity.runCommand(`effect @s slowness 9999 1 true`);
                    entity.runCommand(`effect @s speed 9999 1 true`);
                }
                else if(chargeTime >= 7) {
                    entity.runCommand(`effect @s slowness 9999 0 true`);
                    entity.runCommand(`effect @s speed 9999 0 true`);
                }
                if(entity.runCommand(`testfor @s[scores={using_nex_bow=1}]`).successCount == 0) {
                    system.clearRun(testLoop);
                    chargeTime = 0;
                    entity.runCommand(`effect @s slowness 0`);
                    entity.runCommand(`effect @s speed 0`);
                    return;
                }
                chargeTime++;
                entity.runCommand(`scoreboard players set @s using_nex_bow 1`);
            }, 0);
        }
    }
});

world.afterEvents.itemStopUse.subscribe((eventData) => {
    const item = eventData.itemStack;
    const entity = eventData.source;
    try { 
        if(item.typeId == bowName || item.typeId == bowName2 || item.typeId == bowName3 || item.typeId == bowName4) {
            entity.runCommand(`scoreboard players set @s using_nex_bow 0`);
        }
    } catch {}
});

world.afterEvents.itemReleaseUse.subscribe((eventData) => {
    const item = eventData.itemStack;
    const iDur = eventData.useDuration;
    var dur = 20000-iDur;
    const entity = eventData.source;

    var container = entity.getComponent('minecraft:inventory').container;
    var hasArrow = hasArrowTest(container);

    if((item.typeId == bowName || item.typeId == bowName2 || item.typeId == bowName3 || item.typeId == bowName4) && (hasArrow || entity.runCommand(`testfor @s[m=c]`).successCount == 1)) {
        const identifier = world.scoreboard.getObjective("identifier").getScore(entity);
        entity.runCommand(`scoreboard players set @s using_nex_bow 1`);
        
        //if(entity.runCommand(`testfor @s[m=c]`).successCount != 1) {
        //    entity.runCommand(`scoreboard players set @s nex_bow_dur 1`);
        //    entity.runCommand(`clear @s arrow -1 1`);
        //}

        let viewVector = entity.getViewDirection();
        const playerRotation = entity.getRotation();
        if (playerRotation.x > 30) {
            viewVector.x *= 2.1;
            viewVector.y *= 2.1;
            viewVector.z *= 2.1;
        }
        const { x, y, z } = Vector.addVectors(entity.getHeadLocation(), viewVector);

        var multiplier = 1;
        if(dur > 25) {
            dur = 25;
            multiplier = 1.2;
        }
        var power = dur/3.125;
        var spread = 0.006;

        //entity.runCommand(`playsound random.bow`);
        entity.runCommand(`kill @e[type=arrow,c=1,r=15]`);

        const projectile = entity.dimension.spawnEntity(arrowName, { 'x': x, 'y': y, 'z': z });
        projectile.setRotation({ x: -playerRotation.x, y: -playerRotation.y});
        projectile.applyImpulse(new Vector.constructor((viewVector.x+randomNum(-spread, spread)) * power, (viewVector.y+randomNum(-spread, spread)) * power, (viewVector.z+randomNum(-spread, spread)) * power));
        projectile.runCommand(`scoreboard players set @s identifier ${identifier}`);
        
        var damage = Math.round(power*2.8*0.43*multiplier);
        if(damage == 0) {
            damage = 1;
        }
        projectile.runCommand(`scoreboard players set @s arrow_dmg ${damage}`); 
        if(multiplier == 1.2) { 
            projectile.runCommand(`scoreboard players set @s is_critical 1`); 
        }
        else {
            projectile.runCommand(`scoreboard players set @s is_critical 0`); 
        }
    }
});

function hasArrowTest(container) {
    var hasArrow = false;

    for(var i=0; i<container.size; i++) {
        var name;
        try {name = container.getItem(i).typeId; }
        catch { name = ""; }
        if(name == "minecraft:arrow") {
            hasArrow = true;
        }
    }
    return hasArrow;
}

function randomNum(min, max) {
	return Math.random() * (max - min) + min;
}


world.afterEvents.projectileHitEntity.subscribe(async (eventData) => {
    const projectile = eventData.projectile;
    try { eventData.getEntityHit().entity; projectile.location; eventData.getEntityHit().entity.getComponent('health').currentValue; }
    catch { return; }

    var target = eventData.getEntityHit().entity;
    const hitVector = eventData.hitVector;
    var damage;

    var otherId;
    try { otherId = world.scoreboard.getObjective("identifier").getScore(target); }
    catch { otherId = 0; }

    if(projectile.typeId == arrowName) {
        try { damage = world.scoreboard.getObjective("arrow_dmg").getScore(projectile); }
        catch { damage = 3; }


        target.applyDamage(damage, { damagingProjectile: projectile} );
        target.applyKnockback(hitVector.x, hitVector.z, Math.sqrt(0.9*damage), 0.4);
        var identifier;
        try { identifier = world.scoreboard.getObjective("identifier").getScore(projectile); }
        catch { identifier = undefined; }
        if(identifier != otherId) {

            if(target.runCommand(`testfor @a[scores={identifier=${identifier}},hasitem=[{item=yes:nexus_helmet,location=slot.armor.head},{item=yes:nexus_chestplate,location=slot.armor.chest},{item=yes:nexus_leggings,location=slot.armor.legs},{item=yes:nexus_boots,location=slot.armor.feet}]]`).successCount == 1) {
                target.runCommand(`scoreboard players set @s hit_id ${identifier}`);
            }
            target.runCommand(`tag @e[type=${snowballName},scores={identifier=${identifier}}] add attack`);
            var player = target.dimension.getEntities({type: "player", scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]})[0];
            if(player.runCommand(`testfor @s[hasitem={item=yes_nexus:bow,location=slot.weapon.mainhand}]`).successCount == 1) {
                player.runCommand(`scoreboard players set @e[type=${snowballName},scores={identifier=${identifier}}] arrow_dmg 15`);
            }
            else if(player.runCommand(`testfor @s[hasitem={item=yes_nexus_ad1:bow,location=slot.weapon.mainhand}]`).successCount == 1) {
                player.runCommand(`scoreboard players set @e[type=${snowballName},scores={identifier=${identifier}}] arrow_dmg 16`);
            }
            else if(player.runCommand(`testfor @s[hasitem={item=yes_nexus_ad2:bow,location=slot.weapon.mainhand}]`).successCount == 1) {
                player.runCommand(`scoreboard players set @e[type=${snowballName},scores={identifier=${identifier}}] arrow_dmg 18`);
            }
            else if(player.runCommand(`testfor @s[hasitem={item=yes_nexus_ad3:bow,location=slot.weapon.mainhand}]`).successCount == 1) {
                player.runCommand(`scoreboard players set @e[type=${snowballName},scores={identifier=${identifier}}] arrow_dmg 20`);
            }

            if(target.isValid) {
                startSendingProjectiles(projectile, target);
            }
            projectile.remove();
        }
    }
    else if(projectile.typeId == snowballName) {
        var identifier;
        try { identifier = world.scoreboard.getObjective("identifier").getScore(projectile); }
        catch { identifier = undefined; }
        if(identifier != otherId) {
            var player = target.dimension.getEntities({type: "player", scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]})[0];
            
            damage = world.scoreboard.getObjective("arrow_dmg").getScore(projectile)/10;
            var targetHasShield = (target.runCommand(`testfor @s[hasitem={item=shield,location=slot.weapon.mainhand}]`) || target.runCommand(`testfor @s[hasitem={item=shield,location=slot.weapon.offhand}]`));

            if(projectile.runCommand(`testfor @s[tag=start_attacking]`).successCount == 1) {
                if(target.isSneaking && targetHasShield) {
                    target.applyDamage(damage*2, { damagingProjectile: projectile} );
                }
                else {
                    target.applyDamage(damage, { damagingEntity: player, cause: "override" } );
                }
                target.applyKnockback(hitVector.x, hitVector.z, Math.sqrt(0.9*damage), 0.1);
            }
            else {
                damage = 5;
                if(target.typeId != "minecraft:player") {
                    target.applyDamage(damage, { damagingProjectile: projectile} );
                }
                var targetViewDir = target.getViewDirection();
                target.clearVelocity();
                target.applyKnockback(-targetViewDir.x, -targetViewDir.z, Math.sqrt(0.9*damage), 0.1);
            }
            projectile.kill();
        }
    }
});



function startSendingProjectiles(projectile, target) {
    var identifier = world.scoreboard.getObjective("identifier").getScore(projectile);
    var projList = projectile.dimension.getEntities({type: snowballName, tags: ["attack"], scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]});
    var player = projectile.dimension.getEntities({type: "minecraft:player", scoreOptions:[{objective: "identifier", maxScore: identifier, minScore: identifier}]})[0];
    var listLength = projList.length;
    var repeat = 0;
    //console.warn(`projList: ${projList}`);
    const attackLoop = system.runInterval(() => {
        if(!target.getComponent('health').currentValue > 0) {
            system.clearRun(attackLoop); 
            return; 
        }
        //Performance Check//console.warn(`3 proj shoot loop`);
        //Performance Check//world.scoreboard.getObjective("loopTime").addScore("shoot_loop", 1);
        let playerLocation = player.getHeadLocation();
        let mobLocation = target.getHeadLocation();

        try { 
            projList[repeat].runCommand(`tag @s add start_attacking`); 
        } catch {}
        //adding projectile curve randomizers

        try {
            var distance = Math.sqrt(Math.pow(mobLocation.x-playerLocation.x,2)+Math.pow(mobLocation.z-playerLocation.z,2)+Math.pow(mobLocation.y-playerLocation.y,2));
            var xRand = Math.random()*distance * (Math.round(Math.random()) == 1 ? 1 : -1);
            xRand = Math.round(xRand*100);
            if(xRand == 0) {
                xRand += 0.01;
            }
            //console.warn(xRand);
            var yRand = Math.random()*distance/3 * (Math.round(Math.random()) == 1 ? 1 : -1);
            yRand = Math.round(yRand*100);
            if(yRand > 600) {
                yRand = 600;
            }
            else if(yRand < -600) {
                yRand = -600;
            }

            //console.warn(`xRand ${xRand}`);
            //console.warn(`yRand OLD ${yRand}`);
            projList[repeat].runCommand(`scoreboard players set @s proj_ticks 1`);
            projList[repeat].runCommand(`scoreboard players set @s proj_xRand ${xRand}`);
            projList[repeat].runCommand(`scoreboard players set @s proj_yRand ${yRand}`);
        } catch {}


        repeat++;
        if(repeat >= listLength || !target.isValid) {
            system.clearRun(attackLoop); 
            return; 
        }
    }, 3);
}
world.afterEvents.entitySpawn.subscribe(async (eventData) => {
    const entity = eventData.entity;
    if(entity.typeId == arrowName) {
        var is_critical = world.scoreboard.getObjective("is_critical").getScore(entity);
        if(is_critical == 1) {
            const testLoop = system.runInterval(() => {
                try { entity.location }
                catch { 
                    system.clearRun(testLoop); 
                    return; 
                }
                //Performance Check//console.warn(`4 arrow loop`);
                //Performance Check//world.scoreboard.getObjective("loopTime").addScore("arrow_loop", 1);

                entity.runCommand(`particle yes:basic_crit_particle`);
                let velo = entity.getVelocity();
                var speed = Math.sqrt(velo.x*velo.x + velo.y*velo.y + velo.z*velo.z);
                //console.warn(speed);
                if(speed < 0.001) {
                    system.clearRun(testLoop); 
                    return; 
                }
            }, 0);
        }
    }
    else if(entity.typeId == snowballName) {
        const particleoop = system.runInterval(() => {
            try { entity.location }
            catch { 
                system.clearRun(particleoop); 
                return; 
            }
            //Performance Check//console.warn(`5 snowball loop`);
            //Performance Check//world.scoreboard.getObjective("loopTime").addScore("snowball_loop", 1);

            if(entity.runCommand(`testfor @s[tag=start_attacking]`).successCount == 1) {
                //console.warn(`particlng`);
                entity.runCommand(`particle yes:nexus_projectile_particle`);
            }
            var identifier = world.scoreboard.getObjective("identifier").getScore(entity);
            try { 
                if(entity.runCommand(`testfor @a[scores={identifier=${identifier}}]`).successCount == 0) {
                    entity.kill();
                    system.clearRun(particleoop); 
                    return; 
                }
            } catch {}
        }, 0)
    }


    //for testing purposes
    
    /*
    if(entity.typeId == "minecraft:husk") {
        
        //time = x
        var ticks = 1;

        //xRand = h,  random point where function becomes different
        var xRand;
        //yRand = k,  maximum y displacement of proj
        var yRand;

        
        var playerLocationX = 12;
        var playerLocationY = 78;
        var playerLocationZ = 14;

        var mobLocationX = 12;
        var mobLocationY = 83;
        var mobLocationZ = 34;

        var distance = Math.sqrt(Math.pow(mobLocationX-playerLocationX,2)+Math.pow(mobLocationZ-playerLocationZ,2));

        var maxTime = 3/4*Math.sqrt(distance/10);
        var maxTick = Math.round(maxTime*20);

        const testLoop = system.runInterval(() => {
            try { entity.location }
            catch { 
                system.clearRun(testLoop); 
                return; 
            }
            if(ticks > maxTick) {
                ticks = 1;
                
                entity.runCommand(`tp @s 12 78 14`);
            }

            if(ticks == 1) {
                xRand = Math.random()*distance * (Math.round(Math.random()) == 1 ? 1 : -1);
                if(xRand == 0) {
                    xRand += 0.01;
                }
                //console.warn(xRand);
                yRand = Math.random()*distance/3 * (Math.round(Math.random()) == 1 ? 1 : -1);
                //console.warn(yRand);
            }

            //var time = (ticks/maxTick)*distance;
            var time = (2/45)*Math.pow(ticks,2);
            //console.warn(time);
            playerLocationX = 12;
            playerLocationY = 78;
            playerLocationZ = 14;

            mobLocationX = 12;
            mobLocationY = 83;
            mobLocationZ = 24;
            //for projectile motion



            //distance = p
            distance = Math.sqrt(Math.pow(mobLocationX-playerLocationX,2)+Math.pow(mobLocationZ-playerLocationZ,2));
            
            //xRand = 5;
            //yRand = 2;

            //a1 = a1,  slope of function 1
            var a1 = -(yRand/(-time*distance+2*time*xRand-Math.pow(xRand,2)));

            var xDir;
            if(time <= xRand) { xDir = projFunction1(a1, time, xRand, yRand); }
            else { 
                //a2 = a2,  slope of function 2
                var a2 = (yRand/(-Math.pow(xRand,2)-Math.pow(distance,2)+2*xRand*distance));
                xDir = projFunction2(a2, time, xRand, yRand);  
            }
            var yDir = time*(mobLocationY-playerLocationY)/distance;

            var vector2 = Math.sqrt(xDir*xDir+time*time);
            var vector3 = Math.sqrt(vector2*vector2+Math.pow(yDir,2));

            var iThetaX = Math.atan(xDir/time);
            var iThetaY = Math.atan(yDir/vector2);
            //console.warn(iTheta);
            var player = entity.dimension.getEntities({type: "minecraft:player"})[0];

            //var playerRot = player.getRotation();
            //console.warn(`${playerRot.x} ${playerRot.y}`);

            var angle = world.scoreboard.getObjective("angle").getScore(player);
            var theta = angle*(Math.PI/180);

            var combT = roundToZero(iThetaX+theta);
            var sine = roundToZero(Math.sin(combT));
            var cosine = roundToZero(Math.cos(combT));

            var combTY = roundToZero(iThetaY);
            var sineY = roundToZero(Math.sin(combTY));
            var cosineY = roundToZero(Math.cos(combTY));
            entity.runCommand(`execute positioned 12 78 14 as @s run tp @s ~${vector2*sine*cosineY}  ~${vector3*sineY}  ~${vector2*cosine*cosineY}`);
            //console.warn(time);

            let hPos = entity.getHeadLocation();
            console.warn(`${hPos.x}, ${hPos.y}, ${hPos.z}`);
            ticks++;

        }, 0);
    }
    */
});

function roundToZero(n) {
    if(Math.abs(n) < 0.0001) {
        return 0;
    }
    return n;
}
//x = time
//h = xRand
//k = yRand
function projFunction1(a1, x, h, k) {
    return -a1*Math.pow(x-h,2)+k;
}

//x = time
//h = xRand
//k = yRand
function projFunction2(a2, x, h, k) {
    return a2*Math.pow(x-h,2)+k;
}





world.afterEvents.projectileHitBlock.subscribe(async (eventData) => {
    const projectile = eventData.projectile;
    if(projectile.typeId == snowballName) {
        projectile.kill();
    }
});